/*
 * Generated by XDoclet - Do not edit!
 */
package com.clustercontrol.accesscontrol.ejb.session;

/**
 * Remote interface for AccessController.
 * @xdoclet-generated at ${TODAY}
 * @copyright The XDoclet Team
 * @author XDoclet
 * @version ${version}
 */
public interface AccessController
   extends javax.ejb.EJBObject
{
   /**
    * アクセス[ユーザ]ビューのテーブル定義情報を返します。<BR> リストに、カラム毎にテーブルカラム情報をセットします。
    * @param locale ロケール情報
    * @return テーブル定義情報（{@link com.clustercontrol.bean.TableColumnInfo}のリスト）    */
   public java.util.ArrayList getUserListTableDefine( java.util.Locale locale )
      throws java.rmi.RemoteException;

   /**
    * ユーザ一覧情報を取得します。
    * @return ユーザ一覧情報（Objectの2次元配列）
    * @throws FinderException
    * @throws NamingException
    * @see com.clustercontrol.accesscontrol.factory.SelectUser#getUserList()    */
   public java.util.ArrayList getUserList(  )
      throws javax.ejb.FinderException, javax.naming.NamingException, java.rmi.RemoteException;

   /**
    * ユーザ一覧情報を取得します。
    * @param property ユーザフィルタ用プロパティ
    * @return ユーザ一覧情報（Objectの2次元配列）
    * @throws FinderException
    * @throws NamingException
    * @see com.clustercontrol.accesscontrol.factory.SelectUser#getUserList(Property)    */
   public java.util.ArrayList getUserList( com.clustercontrol.bean.Property property )
      throws javax.ejb.FinderException, javax.naming.NamingException, java.rmi.RemoteException;

   /**
    * ユーザフィルタ用プロパティを返します。
    * @param locale ロケール情報
    * @return ユーザフィルタ用プロパティ
    * @see com.clustercontrol.accesscontrol.factory.UserFilterProperty#getProperty(Locale)    */
   public com.clustercontrol.bean.Property getUserFilterProperty( java.util.Locale locale )
      throws java.rmi.RemoteException;

   /**
    * ユーザ用プロパティを返します。
    * @param uid ユーザID
    * @param mode プロパティモード
    * @param locale ロケール情報
    * @return ユーザ用プロパティ
    * @throws FinderException
    * @throws NamingException
    * @see com.clustercontrol.bean.PropertyConstant
    * @see com.clustercontrol.accesscontrol.factory.UserProperty#getProperty(String, int, Locale)    */
   public com.clustercontrol.bean.Property getUserProperty( java.lang.String uid,int mode,java.util.Locale locale )
      throws javax.ejb.FinderException, javax.naming.NamingException, java.rmi.RemoteException;

   /**
    * ユーザを追加します。
    * @param property ユーザ用プロパティ
    * @throws NamingException
    * @throws CreateException
    * @throws FinderException
    * @throws ParseException
    * @see com.clustercontrol.accesscontrol.factory.ModifyUser#addUser(Property, String)    */
   public void addUser( com.clustercontrol.bean.Property property )
      throws javax.naming.NamingException, javax.ejb.CreateException, javax.ejb.FinderException, java.text.ParseException, java.rmi.RemoteException;

   /**
    * ユーザを変更します。
    * @param property ユーザ用プロパティ
    * @throws NamingException
    * @throws FinderException
    * @see com.clustercontrol.accesscontrol.factory.ModifyUser#modifyUser(Property, String)    */
   public void modifyUser( com.clustercontrol.bean.Property property )
      throws javax.naming.NamingException, javax.ejb.FinderException, java.rmi.RemoteException;

   /**
    * ユーザを削除します。
    * @param uid ユーザID
    * @throws NamingException
    * @throws RemoveException
    * @throws FinderException
    * @see com.clustercontrol.accesscontrol.factory.ModifyUser#deleteUser(String)    */
   public void deleteUser( java.lang.String uid )
      throws javax.naming.NamingException, javax.ejb.RemoveException, javax.ejb.FinderException, java.rmi.RemoteException;

   /**
    * パスワードを変更します。
    * @param uid ユーザID
    * @param password パスワード
    * @throws NamingException
    * @throws RemoveException
    * @throws FinderException
    * @see com.clustercontrol.accesscontrol.factory.ModifyUser#modifyPassword(String, String)    */
   public void changePassword( java.lang.String uid,java.lang.String password )
      throws javax.naming.NamingException, javax.ejb.RemoveException, javax.ejb.FinderException, java.rmi.RemoteException;

   /**
    * ログインユーザが指定したRoleの権限を持っているかチェックします。
    * @param roleName Role名
    * @return 権限の有無（true：権限あり、false：権限なし）
    * @throws NamingException    */
   public boolean isPermission( java.lang.String roleName )
      throws javax.naming.NamingException, java.rmi.RemoteException;

   /**
    * ログインユーザのユーザ名を返します。
    * @return ユーザ名
    * @throws NamingException
    * @throws FinderException
    * @see com.clustercontrol.accesscontrol.factory.SelectUser#getUserName(String)    */
   public java.lang.String getUserName(  )
      throws javax.naming.NamingException, javax.ejb.FinderException, java.rmi.RemoteException;

}
