/*
 * Generated by XDoclet - Do not edit!
 */
package com.clustercontrol.jobmanagement.ejb.session;

/**
 * Local interface for JobRunManagement.
 * @xdoclet-generated at ${TODAY}
 * @copyright The XDoclet Team
 * @author XDoclet
 * @version ${version}
 */
public interface JobRunManagementLocal
   extends javax.ejb.EJBLocalObject
{
   /**
    * Quartzへジョブ管理の定周期処理を登録します。<BR> Quartzからは、{@link com.clustercontrol.jobmanagement.ejb.session.JobRunManagementBean#run()} が呼び出されます。
    * @param cronString cronの定義文字列
    * @throws NamingException
    * @throws ParseException
    * @throws SchedulerException
    * @see com.clustercontrol.quartzmanager.ejb.session.QuartzManager#addSchedule(org.quartz.JobDetail, org.quartz.Trigger)
    * @see com.clustercontrol.quartzmanager.ejb.session.QuartzManager#deleteSchedule(java.lang.String, java.lang.String)
    * @see com.clustercontrol.jobmanagement.ejb.session.JobRunManagementHome#JNDI_NAME
    * @see com.clustercontrol.jobmanagement.ejb.session.JobRunManagementBean#GROUP_NAME    */
   public void addQuartz( java.lang.String cronString ) throws javax.naming.NamingException, java.text.ParseException, org.quartz.SchedulerException;

   /**
    * Quartzからジョブ管理の定周期処理を削除します。
    * @throws NamingException
    * @throws ParseException
    * @throws SchedulerException
    * @see com.clustercontrol.quartzmanager.ejb.session.QuartzManager#deleteSchedule(java.lang.String, java.lang.String)
    * @see com.clustercontrol.jobmanagement.ejb.session.JobRunManagementHome#JNDI_NAME
    * @see com.clustercontrol.jobmanagement.ejb.session.JobRunManagementBean#GROUP_NAME    */
   public void deleteQuartz(  ) throws javax.naming.NamingException, java.text.ParseException, org.quartz.SchedulerException;

   /**
    * Quartzからのコールバックメソッド <P> Quartzから定周期で呼び出されます。<BR> <BR> 実行状態が実行中のセッションをチェックし、実行可能なジョブを開始する。<BR> 実行状態が待機のセッションをチェックし、ジョブを開始する。
    * @throws FinderException
    * @throws NamingException
    * @see com.clustercontrol.jobmanagement.factory.OperationJob#runJob()
    * @see com.clustercontrol.jobmanagement.ejb.session.JobRunManagementBean#runWaitJob()    */
   public void run(  ) throws javax.ejb.FinderException, javax.naming.NamingException;

   /**
    * 実行状態が待機のセッションのジョブを実行します。<P> 実行状態の待機のセッションをチェックし、ジョブを開始する。
    * @throws NamingException
    * @throws FinderException
    * @see com.clustercontrol.jobmanagement.factory.OperationJob#runWaitJob()    */
   public void runWaitJob(  ) throws javax.naming.NamingException, javax.ejb.FinderException;

   /**
    * 実行状態が停止処理中のセッションのジョブをチェックします。<P> 実行状態の停止処理中のセッションをチェックし、ジョブを停止する。
    * @throws NamingException
    * @throws FinderException
    * @see com.clustercontrol.jobmanagement.factory.OperationJob#checkStoppingJob()    */
   public void checkStoppingJob(  ) throws javax.naming.NamingException, javax.ejb.FinderException;

   /**
    * ジョブを実行します。
    * @param sessionId セッションID
    * @param jobId ジョブID
    * @throws FinderException
    * @throws NamingException
    * @see com.clustercontrol.jobmanagement.factory.OperationJob#runJob(String, String)    */
   public void runJob( java.lang.String sessionId,java.lang.String jobId ) throws javax.ejb.FinderException, javax.naming.NamingException;

   /**
    * ジョブの操作を行います。
    * @param property ジョブ操作用プロパティ
    * @throws FinderException
    * @throws NamingException
    * @see com.clustercontrol.jobmanagement.factory.OperateStartOfJob#startJob(String, String, String)
    * @see com.clustercontrol.jobmanagement.factory.OperateSuspendOfJob#suspendJob(String, String)
    * @see com.clustercontrol.jobmanagement.factory.OperateSuspendOfJob#releaseSuspendJob(String, String)
    * @see com.clustercontrol.jobmanagement.factory.OperateWaitOfJob#waitJob(String, String)
    * @see com.clustercontrol.jobmanagement.factory.OperateWaitOfJob#releaseWaitJob(String, String)
    * @see com.clustercontrol.jobmanagement.factory.OperateSkipOfJob#skipJob(String, String, Integer)
    * @see com.clustercontrol.jobmanagement.factory.OperateSkipOfJob#releaseSkipJob(String, String)
    * @see com.clustercontrol.jobmanagement.factory.OperateStopOfJob#stopJob(String, String, String)
    * @see com.clustercontrol.jobmanagement.factory.OperateMaintenanceOfJob#maintenanceJob(String, String, String, Integer)    */
   public void operationJob( com.clustercontrol.bean.Property property ) throws javax.ejb.FinderException, javax.naming.NamingException;

   /**
    * ノード終了処理を行います。
    * @param info 実行結果情報
    * @throws FinderException
    * @throws NamingException
    * @see com.clustercontrol.jobmanagement.factory.OperationJob#endNode(RunResultInfo)    */
   public void endNode( com.clustercontrol.jobmanagement.message.RunResultInfo info ) throws javax.ejb.FinderException, javax.naming.NamingException;

}
