/*
 * Generated by XDoclet - Do not edit!
 */
package com.clustercontrol.notify.ejb.session;

/**
 * Local interface for NotifyController.
 * @xdoclet-generated at ${TODAY}
 * @copyright The XDoclet Team
 * @author XDoclet
 * @version ${version}
 */
public interface NotifyControllerLocal
   extends javax.ejb.EJBLocalObject
{
   /**
    * 通知情報を作成します。
    * @param info 作成対象の通知情報
    * @return 作成に成功した場合、<code> true </code>
    * @throws CreateException
    * @throws NamingException
    * @throws JMSException
    * @see com.clustercontrol.notify.factory.AddNotify#add(NotifyInfo)    */
   public boolean addNotify( com.clustercontrol.notify.bean.NotifyInfo info ) throws javax.ejb.CreateException, javax.naming.NamingException, javax.jms.JMSException;

   /**
    * 通知情報を変更します。
    * @param info 変更対象の通知情報
    * @return 変更に成功した場合、<code> true </code>
    * @throws CreateException
    * @throws FinderException
    * @throws RemoveException
    * @throws NamingException
    * @throws JMSException
    * @see com.clustercontrol.notify.factory.ModifyNotify#modify(NotifyInfo)    */
   public boolean modifyNotify( com.clustercontrol.notify.bean.NotifyInfo info ) throws javax.ejb.CreateException, javax.ejb.FinderException, javax.ejb.RemoveException, javax.naming.NamingException, javax.jms.JMSException;

   /**
    * 通知情報を削除します。
    * @param notifyId 削除対象の通知ID
    * @return 削除に成功した場合、<code> true </code>
    * @throws FinderException
    * @throws RemoveException
    * @throws NamingException
    * @throws JMSException
    * @see com.clustercontrol.notify.factory.DeleteNotify#delete(String)    */
   public boolean deleteNotify( java.lang.String notifyId ) throws javax.ejb.FinderException, javax.ejb.RemoveException, javax.naming.NamingException, javax.jms.JMSException;

   /**
    * 引数で指定された通知情報を返します。
    * @param notifyId 取得対象の通知ID
    * @return 通知情報
    * @throws CreateException
    * @throws FinderException
    * @throws NamingException
    * @see com.clustercontrol.notify.factory.SelectNotify#getNotify(String)    */
   public com.clustercontrol.notify.bean.NotifyInfo getNotify( java.lang.String notifyId ) throws javax.ejb.FinderException, javax.naming.NamingException;

   /**
    * 通知ID一覧を返します。
    * @return 通知ID一覧
    * @throws CreateException
    * @throws FinderException
    * @throws NamingException
    * @see com.clustercontrol.notify.factory.SelectNotify#getNotifyIdList()    */
   public java.util.ArrayList getNotifyIdList(  ) throws javax.ejb.CreateException, javax.ejb.FinderException, javax.naming.NamingException;

   /**
    * 通知情報一覧を返します。
    * @return 通知情報一覧（Objectの2次元配列）
    * @throws CreateException
    * @throws FinderException
    * @throws NamingException
    * @see com.clustercontrol.notify.factory.SelectNotify#getNotifyList()    */
   public java.util.ArrayList getNotifyList(  ) throws javax.ejb.CreateException, javax.ejb.FinderException, javax.naming.NamingException;

   /**
    * 通知情報マップを返します。
    * @return 通知情報マップ
    * @throws FinderException
    * @throws NamingException
    * @see com.clustercontrol.notify.factory.SelectNotify#getNotifyMap()    */
   public java.util.HashMap getNotifyMap(  ) throws javax.ejb.FinderException, javax.naming.NamingException;

   /**
    * 通知情報一覧のテーブル定義情報を返します。<BR> リストに、カラム毎にテーブルカラム情報をセットします。
    * @param locale ロケール情報
    * @return テーブル定義情報（{@link com.clustercontrol.bean.TableColumnInfo}のリスト）
    * @see com.clustercontrol.bean.TableColumnInfo#TableColumnInfo(java.lang.String, int, int, int)
    * @see com.clustercontrol.notify.bean.NotifyTabelDefine    */
   public java.util.ArrayList getNotifyListTableDefine( java.util.Locale locale ) ;

   /**
    * システム通知情報を作成します。
    * @param info 作成対象のシステム通知情報
    * @return 作成に成功した場合、<code> true </code>
    * @throws CreateException
    * @throws NamingException
    * @throws JMSException
    * @see com.clustercontrol.notify.factory.AddSystemNotify#add(NotifyInfo)    */
   public boolean addSystemNotify( com.clustercontrol.notify.bean.NotifyInfo info ) throws javax.ejb.CreateException, javax.naming.NamingException, javax.jms.JMSException;

   /**
    * システム通知情報を変更します。
    * @param info 変更対象のシステム通知情報
    * @return 変更に成功した場合、<code> true </code>
    * @throws CreateException
    * @throws FinderException
    * @throws RemoveException
    * @throws NamingException
    * @throws JMSException
    * @see com.clustercontrol.notify.factory.ModifySystemNotify#modify(NotifyInfo)    */
   public boolean modifySystemNotify( com.clustercontrol.notify.bean.NotifyInfo info ) throws javax.ejb.CreateException, javax.ejb.FinderException, javax.ejb.RemoveException, javax.naming.NamingException, javax.jms.JMSException;

   /**
    * システム通知情報を削除します。
    * @param notifyId 削除対象の通知ID
    * @return 削除に成功した場合、<code> true </code>
    * @throws FinderException
    * @throws RemoveException
    * @throws NamingException
    * @throws JMSException
    * @see com.clustercontrol.notify.factory.DeleteSystemNotify#delete(String)    */
   public boolean deleteSystemNotify( java.lang.String notifyId ) throws javax.ejb.FinderException, javax.ejb.RemoveException, javax.naming.NamingException, javax.jms.JMSException;

   /**
    * 引数で指定されたシステム通知情報を返します。
    * @param notifyId 取得対象の通知ID
    * @return システム通知情報
    * @throws CreateException
    * @throws FinderException
    * @throws NamingException
    * @see com.clustercontrol.notify.factory.SelectSystemNotify#getNotify(String)    */
   public com.clustercontrol.notify.bean.NotifyInfo getSystemNotify( java.lang.String notifyId ) throws javax.ejb.FinderException, javax.naming.NamingException;

}
