/*
 * Generated by XDoclet - Do not edit!
 */
package com.clustercontrol.performanceMGR.ejb.session;

/**
 * Remote interface for CollectorController.
 * @since 1.0 <!-- begin-xdoclet-definition -->
 * @generated 
 * @xdoclet-generated at ${TODAY}
 * @copyright The XDoclet Team
 * @author XDoclet
 * @version ${version}
 */
public interface CollectorController
   extends javax.ejb.EJBObject
{
   /**
    * リアルタイム収集用のEntityBeanを生成します。
    * @param facilityID ファシリティID
    * @param interval 収集間隔
    * @param colletorItemList　収集項目設定のリスト
    */
   public void createRealtimeColletor( java.lang.String facilityID,int interval,java.util.List colletorItemList )
      throws java.rmi.RemoteException;

   /**
    * リアルタイム収集の収集済みデータを取得します。
    * @param facilityID ファシリティID
    * @param itemID　収集項目ID
    * @param option　取得の対象を指示（指定スコープ（CURRENT_SCOPE）もしくは指定スコープのサブスコープ（SUB_SCOPE））
    * @return　収集済み性能データのコレクション 
    */
   public java.util.Collection getRealtimeCollectedData( java.lang.String facilityID,int itemID,int option )
      throws java.rmi.RemoteException;

   /**
    * リアルタイム収集の収集済みデータを取得します。
    * @param facilityID　ファシリティID
    * @param itemIDs 収集項目の配列
    * @return 収集済み性能データのコレクション
    */
   public java.util.Collection getRealtimeCollectedData( java.lang.String facilityID,int[] itemIDs )
      throws java.rmi.RemoteException;

   /**
    * リアルタイム収集の収集済みデータを取得します。 指定のファシリティで収集されている全ての収集項目の性能値データを取得します。
    * @param facilityID
    * @return 収集済み性能データのコレクション
    */
   public java.util.Collection getRealtimeCollectedDataAll( java.lang.String facilityID )
      throws java.rmi.RemoteException;

   /**
    * 収集設定のプロパティ情報を取得します。
    * @param collectorID 収集ID
    * @return 収集設定のプロパティ情報
    */
   public com.clustercontrol.performanceMGR.bean.CollectorProperty getCollectorProperty( java.lang.String collectorID )
      throws java.rmi.RemoteException;

   /**
    * 実績情報収集用のEntityBeanを生成します。
    * @param collectorDef　収集の定義情報
    */
   public void createRecordColletor( com.clustercontrol.performanceMGR.bean.CollectorProperty collectorDef )
      throws javax.ejb.DuplicateKeyException, java.rmi.RemoteException;

   /**
    * 実績収集を停止します。
    * @param collectorID 停止したい収集ID
    */
   public void stopRecordCollector( java.lang.String collectorID )
      throws java.rmi.RemoteException;

   /**
    * 実績収集で収集されたデータを取得します。
    * @param collectorID 収集ID
    * @param facilityID　ファシリティID
    * @param itemID　収集項目ID
    * @param startDate　取得したい始点の時刻
    * @param endDate　　取得した終点の時刻
    * @return　収集データのデータセット 
    */
   public java.util.List getRecordCollectedData( com.clustercontrol.performanceMGR.bean.CollectorItemInfo item,java.lang.String facilityID,java.util.Date startDate,java.util.Date endDate )
      throws java.rmi.RemoteException;

   /**
    * 実績収集で収集されたデータを取得します。
    * @param collectorID 収集ID
    * @param facilityIDs　ファシリティIDの配列
    * @param itemIDs　収集項目IDの配列
    * @param startDate　取得したい始点の時刻
    * @param endDate　　取得した終点の時刻
    * @return　収集データのデータセット 
    */
   public com.clustercontrol.performanceMGR.bean.CollectedDataSet getRecordCollectedData( com.clustercontrol.performanceMGR.bean.CollectorItemInfo[] items,java.lang.String[] facilityIDs,java.util.Date startDate,java.util.Date endDate )
      throws java.rmi.RemoteException;

   /**
    * 実績収集で収集されたデータを取得します。
    * @param collectorID 収集ID
    * @param facilityID　ファシリティIDの配列
    * @param itemID　収集項目IDの配列
    * @param startDate　取得したい始点の時刻
    * @param endDate　　取得した終点の時刻
    * @return　収集データのデータセット 
    */
   public com.clustercontrol.performanceMGR.bean.CollectedDataSet getRecordCollectedData( java.lang.String collectorID,java.lang.String[] facilityIDs,int[] itemID,java.util.Date startDate,java.util.Date endDate )
      throws java.rmi.RemoteException;

   /**
    * 実績収集設定及び、収集した性能情報を全て削除します。
    * @param collectorID　削除したい収集ID
    */
   public void deleteRecordCollector( java.lang.String collectorID )
      throws javax.ejb.RemoveException, java.rmi.RemoteException;

   /**
    * 収集設定時のファシリティツリー情報を取得します。
    * @param collectorID 収集ID
    * @return FacilityTreeItem ファシリティツリー
    */
   public com.clustercontrol.bean.FacilityTreeItem getFacilityTree( java.lang.String collectorID )
      throws java.rmi.RemoteException;

   /**
    * 在のリポジトリに登録されているデバイス情報から 指定のファシリティID以下の階層のノードのデバイスのリストを取得します。
    * @param ファシリティID
    * @return デバイス情報のセット
    */
   public com.clustercontrol.performanceMGR.bean.DeviceDataSet getCurrentDeviceSet( java.lang.String facilityID )
      throws java.rmi.RemoteException;

   /**
    * 収集設定に含まれたファシリティのデバイス情報を取得します。
    * @param collectorID　収集ID
    * @return デバイス情報のセット
    */
   public com.clustercontrol.performanceMGR.bean.DeviceDataSet getDeviceSet( java.lang.String collectorID )
      throws javax.ejb.FinderException, javax.naming.NamingException, java.rmi.RemoteException;

   /**
    * 指定の収集IDのデータに対して削除ロックをかけます。
    */
   public void lock( java.lang.String collectorID,com.clustercontrol.performanceMGR.bean.CollectorLockKey key )
      throws java.rmi.RemoteException;

   /**
    * 指定の収集IDのデータに対する削除ロックを解除します。
    */
   public void unlock( com.clustercontrol.performanceMGR.bean.CollectorLockKey key )
      throws java.rmi.RemoteException;

   /**
    * 収集一覧のテーブル定義情報を返します。
    * @generated 
    * @param locale ロケール
    * @return TableColumnInfoの配列    */
   public java.util.ArrayList getCollectionListTableDefine( java.util.Locale locale )
      throws java.rmi.RemoteException;

   /**
    * 実績収集情報を返します。
    * @generated 
    * @return Objectの2次元配列
    * @throws NamingException
    * @throws FinderException    */
   public java.util.ArrayList getCollectionList(  )
      throws java.rmi.RemoteException;

   /**
    * 収集項目コードの一覧を取得します
    * @generated 
    * @return     */
   public java.util.HashMap getItemCodeMap(  )
      throws java.rmi.RemoteException;

   /**
    * 収集項目ツリーを返します
    * @generated 
    * @param facilityId
    * @param collectorId
    * @return     */
   public com.clustercontrol.performanceMGR.util.code.CollectorItemTreeItem[] getCollectorTree( java.lang.String facilityId,java.lang.String collectorId )
      throws java.rmi.RemoteException;

   /**
    * 収集可能な項目のリストを返します
    * @generated 
    * @param facilityId
    * @return     */
   public java.util.List getAvailableCollectorItemList( java.lang.String facilityId )
      throws java.rmi.RemoteException;

   /**
    * アクセス可能かどうかをチェックするためのメソッド 読み込み権限のあるroleで呼び出すとtrueを返す
    * @generated 
    * @return true    */
   public boolean checkPermissionRead(  )
      throws java.rmi.RemoteException;

   /**
    * アクセス可能かどうかをチェックするためのメソッド 書き込み権限のあるroleで呼び出すとtrueを返す
    * @generated 
    * @return true    */
   public boolean checkPerformanceWrite(  )
      throws java.rmi.RemoteException;

   /**
    * アクセス可能かどうかをチェックするためのメソッド 書き込み権限のあるroleで呼び出すとtrueを返す
    * @generated 
    * @return true    */
   public boolean checkPermissionExecute(  )
      throws java.rmi.RemoteException;

   /**
    * ファシリティIDが使用されているかチェックします。 <P> 使用されていたら、UsedFacilityException がスローされる。
    * @param facilityId ファシリティ
    * @throws UsedFacilityException
    * @see com.clustercontrol.commons.ejb.session.CheckFacility#isUseFacilityId(java.lang.String)
    * @see com.clustercontrol.bean.PluginConstant;    */
   public void isUseFacilityId( java.lang.String facilityId )
      throws com.clustercontrol.commons.ejb.UsedFacilityException, java.rmi.RemoteException;

}
