/*
 * Generated by XDoclet - Do not edit!
 */
package com.clustercontrol.performanceMGR.ejb.session;

/**
 * Local interface for CollectorController.
 * @since 1.0 <!-- begin-xdoclet-definition -->
 * @generated 
 * @xdoclet-generated at ${TODAY}
 * @copyright The XDoclet Team
 * @author XDoclet
 * @version ${version}
 */
public interface CollectorControllerLocal
   extends javax.ejb.EJBLocalObject
{
   /**
    * リアルタイム収集用のEntityBeanを生成します。
    * @param facilityID ファシリティID
    * @param interval 収集間隔
    * @param colletorItemList　収集項目設定のリスト
    */
   public void createRealtimeColletor( java.lang.String facilityID,int interval,java.util.List colletorItemList ) ;

   /**
    * リアルタイム収集の収集済みデータを取得します。
    * @param facilityID ファシリティID
    * @param itemID　収集項目ID
    * @param option　取得の対象を指示（指定スコープ（CURRENT_SCOPE）もしくは指定スコープのサブスコープ（SUB_SCOPE））
    * @return　収集済み性能データのコレクション 
    */
   public java.util.Collection getRealtimeCollectedData( java.lang.String facilityID,int itemID,int option ) ;

   /**
    * リアルタイム収集の収集済みデータを取得します。
    * @param facilityID　ファシリティID
    * @param itemIDs 収集項目の配列
    * @return 収集済み性能データのコレクション
    */
   public java.util.Collection getRealtimeCollectedData( java.lang.String facilityID,int[] itemIDs ) ;

   /**
    * リアルタイム収集の収集済みデータを取得します。 指定のファシリティで収集されている全ての収集項目の性能値データを取得します。
    * @param facilityID
    * @return 収集済み性能データのコレクション
    */
   public java.util.Collection getRealtimeCollectedDataAll( java.lang.String facilityID ) ;

   /**
    * 収集一覧のテーブル定義情報を返します。
    * @generated 
    * @param locale ロケール
    * @return TableColumnInfoの配列    */
   public java.util.ArrayList getCollectionListTableDefine( java.util.Locale locale ) ;

   /**
    * 実績収集情報を返します。
    * @generated 
    * @return Objectの2次元配列
    * @throws NamingException
    * @throws FinderException    */
   public java.util.ArrayList getCollectionList(  ) ;

   /**
    * 収集項目コードの一覧を取得します
    * @generated 
    * @return     */
   public java.util.HashMap getItemCodeMap(  ) ;

   /**
    * 収集項目ツリーを返します
    * @generated 
    * @param facilityId
    * @param collectorId
    * @return     */
   public com.clustercontrol.performanceMGR.util.code.CollectorItemTreeItem[] getCollectorTree( java.lang.String facilityId,java.lang.String collectorId ) ;

   /**
    * 収集可能な項目のリストを返します
    * @generated 
    * @param facilityId
    * @return     */
   public java.util.List getAvailableCollectorItemList( java.lang.String facilityId ) ;

   /**
    * アクセス可能かどうかをチェックするためのメソッド 読み込み権限のあるroleで呼び出すとtrueを返す
    * @generated 
    * @return true    */
   public boolean checkPermissionRead(  ) ;

   /**
    * アクセス可能かどうかをチェックするためのメソッド 書き込み権限のあるroleで呼び出すとtrueを返す
    * @generated 
    * @return true    */
   public boolean checkPerformanceWrite(  ) ;

   /**
    * アクセス可能かどうかをチェックするためのメソッド 書き込み権限のあるroleで呼び出すとtrueを返す
    * @generated 
    * @return true    */
   public boolean checkPermissionExecute(  ) ;

   /**
    * ファシリティIDが使用されているかチェックします。 <P> 使用されていたら、UsedFacilityException がスローされる。
    * @param facilityId ファシリティ
    * @throws UsedFacilityException
    * @see com.clustercontrol.commons.ejb.session.CheckFacility#isUseFacilityId(java.lang.String)
    * @see com.clustercontrol.bean.PluginConstant;    */
   public void isUseFacilityId( java.lang.String facilityId ) throws com.clustercontrol.commons.ejb.UsedFacilityException;

}
